Subject: Emacs 28 regression: fill-column is not always respected for the first line of commented block

From: Sergey Vinokurov <[email-masked]>
Date: Wed, 26 Jan 2022 00:14:21 +0000

Hello,

The #45720 bug introduces edge case in treatment of fill-column for the 
first line of commented block. This is caught by haskell-mode tests 
(https://github.com/haskell/haskell-mode/blob/master/tests/haskell-mode-tests.el#L330) 
but is not limited to that mode.

I have managed to reproduce it using the following snippet:

(princ
  (with-temp-buffer
    (asm-mode)
    (dolist (line '("  ;; a b c"
                    "  ;; d e f"
                    "  ;; x y z"
                    "  ;; w"))
      (insert line "\n"))
    (goto-char (point-min))
    (end-of-line)
    (setf fill-column 10)
    (fill-paragraph nil)
    (buffer-string)))

The idea is that everything is already filled and nothing should happen 
when fill-column equals to 10.

On Emacs 27 I get the expected output (snippet above is in /tmp/test.el):

$ emacs --version
GNU Emacs 27.2.50
Copyright (C) 2021 Free Software Foundation, Inc.
GNU Emacs comes with ABSOLUTELY NO WARRANTY.
You may redistribute copies of GNU Emacs
under the terms of the GNU General Public License.
For more information about these matters, see the file named COPYING.
$ emacs -Q --batch -l /tmp/test.el
   ;; a b c
   ;; d e f
   ;; x y z
   ;; w

On Emacs 28 pretest I get:

$ emacs --version
GNU Emacs 28.0.91
Copyright (C) 2022 Free Software Foundation, Inc.
GNU Emacs comes with ABSOLUTELY NO WARRANTY.
You may redistribute copies of GNU Emacs
under the terms of the GNU General Public License.
For more information about these matters, see the file named COPYING.
$ emacs -Q --batch -l /tmp/test.el
   ;; a b c d
   ;; e f x
   ;; y z w

The first line is of length 11 which is in violation of requested 
fill-column equals 10.

Couldn't reproduce for emacs-lisp-mode and c-mode presumably because 
they override fill-paragraph-function so asm-mode is the simplest 
programming related mode I could find in vanilla Emacs. Other modes that 
don't do anything fancy with fill-paragraph-function (e.g. haskell-mode) 
should be susceptible to the issue as well.